//
//  printTestViewController.m
//  printTest
//
//  Created by yasuda on 11/03/01.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "printTestViewController.h"
#import "PrintSinglePageRenderer.h"
#import "PrintGridPageRenderer.h"

@implementation printTestViewController

@synthesize printBarButton;
@synthesize myWebView;
@synthesize gridMultiSegment;

/*
 // The designated initializer. Override to perform setup that is required before the view is loaded.
 - (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
 self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
 if (self) {
 // Custom initialization
 }
 return self;
 }
 */

/*
 // Implement loadView to create a view hierarchy programmatically, without using a nib.
 - (void)loadView {
 }
 */



// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];

	/*
	// 現在のロケールを表示
	NSString *localeIdentifier = [[NSLocale currentLocale] localeIdentifier];
	NSString *localeString = [[NSLocale currentLocale] displayNameForKey:NSLocaleIdentifier value:localeIdentifier];
	NSString *message = [NSString stringWithFormat:@"id=%@ : %@", localeIdentifier, localeString];
	UIAlertView* alert = [[UIAlertView alloc]
						  initWithTitle:@"language"
						  message:message
						  delegate:self
						  cancelButtonTitle:@"OK"
						  otherButtonTitles:nil];
	[alert show];
	[alert release];
	*/
}



/*
 // Override to allow orientations other than the default portrait orientation.
 - (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
 // Return YES for supported orientations
 return (interfaceOrientation == UIInterfaceOrientationPortrait);
 }
 */

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	[myWebView stopLoading];	// in case the web view is still loading its content
	myWebView.delegate = nil;	// disconnect the delegate as the webview is hidden
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
}


- (void)dealloc {
    [super dealloc];
}

// ================================================= 共通ルーチン


// iPad / iPhone でプリントダイアログの出し方（作法）が異なるので
- (void)printContent:(id)pic completionHandler:(UIPrintInteractionCompletionHandler)completionHandler {
	
	if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPad) {
		[pic presentFromBarButtonItem:self.printBarButton animated:YES
					completionHandler:completionHandler];
	} else {
		[pic presentAnimated:YES completionHandler:completionHandler];
	}
	
}

// ================================================= printingItem

// printingItem を使って直接印刷, A4 に, NSData で処理する
- (IBAction)printSimple:(id)sender {
	NSString *fileName, *type;
	
	if([sender tag] == 1) { // sample.jpg
		fileName=@"sample"; type=@"jpg";
	} else { // must be PDF
		fileName=@"sample";	type=@"pdf";
	}

	NSString *path = [[NSBundle mainBundle] pathForResource:fileName ofType:type];
	NSData *myData = [NSData dataWithContentsOfFile: path]; // NSData に読み込む
	
	UIPrintInteractionController *pic = [UIPrintInteractionController sharedPrintController];
	
	if(pic && [UIPrintInteractionController canPrintData: myData] ) {   // canPrintData: でチェック
		
		pic.delegate = self;
		
		UIPrintInfo *printInfo = [UIPrintInfo printInfo];
		printInfo.outputType = UIPrintInfoOutputGeneral;     // A4を指定
		printInfo.jobName = [path lastPathComponent];
		printInfo.duplex =  UIPrintInfoDuplexNone;
		pic.printInfo = printInfo;
		pic.showsPageRange = YES;
		
		pic.printingItem = myData; // NSData を与える

		void (^completionHandler)(UIPrintInteractionController *, BOOL, NSError *) =
		^(UIPrintInteractionController *pic, BOOL completed, NSError *error) {
			//self.content = nil;
			if (!completed && error) {
				NSLog(@"FAILED! due to error in domain %@ with error code %u", error.domain, error.code);
			} 
		};
		
		[self printContent:pic completionHandler:completionHandler];
	}	
}


// printingItem を使って直接印刷, 写真用紙に, NSURL で処理する
- (IBAction)printPhoto:(id)sender {	
	NSString *path = [[NSBundle mainBundle] pathForResource:@"photo" ofType:@"jpg"];
	NSURL *myURL = [NSURL fileURLWithPath: path]; // NSURL で参照
	
	UIPrintInteractionController *pic = [UIPrintInteractionController sharedPrintController];
	
	if(pic && [UIPrintInteractionController canPrintURL:myURL]) {  // canPrintURL: でチェック
		
		pic.delegate = self;
		
		UIPrintInfo *printInfo = [UIPrintInfo printInfo];
		printInfo.outputType = UIPrintInfoOutputPhoto;     // 写真用紙を指定
		printInfo.jobName = [path lastPathComponent];
		printInfo.duplex =  UIPrintInfoDuplexNone;
		pic.printInfo = printInfo;
		pic.showsPageRange = YES;
		
		pic.printingItem = myURL; // NSURL を与える
		
		void (^completionHandler)(UIPrintInteractionController *, BOOL, NSError *) =
		^(UIPrintInteractionController *pic, BOOL completed, NSError *error) {
			//self.content = nil;
			if (!completed && error) {
				NSLog(@"FAILED! due to error in domain %@ with error code %u", error.domain, error.code);
			} 
		};
		
		[self printContent:pic completionHandler:completionHandler];
	}
}

// ================================================= printFormatter

// printFormatter を使って印刷, A4, Text or HTML
- (IBAction)printWithFormatter:(id)sender {	
	NSString *fileName, *type;
	NSString *path;
	NSString *text;
	NSError *error=nil;
	
	if([sender tag] == 3) { // sample.txt
		fileName=@"sample"; type=@"txt";
	} else { // must be HTML
		fileName=@"sample";	type=@"html";
	}
	
	path = [[NSBundle mainBundle] pathForResource:fileName ofType:type];
	text = [[NSString alloc] initWithContentsOfFile:path 
										   encoding:NSUTF8StringEncoding 
											  error:&error];

	if([[error domain]isEqual:NSCocoaErrorDomain]) { // エンコーディングが違っていてもこれが出る
		UIAlertView* alert = [[UIAlertView alloc]
							  initWithTitle:@"data file reading"
							  message:[error localizedDescription]
							  delegate:self
							  cancelButtonTitle:@"OK"
							  otherButtonTitles:nil];
		[alert show];
		[alert release];
		return;
	}

	UIPrintInteractionController *pic = [UIPrintInteractionController sharedPrintController];
	
	if(pic) { 
		pic.delegate = self;

		UIPrintInfo *printInfo = [UIPrintInfo printInfo];
		printInfo.outputType = UIPrintInfoOutputGeneral;     // A4を指定
		printInfo.jobName = [path lastPathComponent];
		printInfo.duplex =  UIPrintInfoDuplexNone;
		pic.printInfo = printInfo;
		pic.showsPageRange = YES;
		
		if([sender tag] == 3) { // text
			UISimpleTextPrintFormatter *textFormatter =            // formatter を用意する
			[[UISimpleTextPrintFormatter alloc] initWithText:text];
			pic.printFormatter = textFormatter;  // formatter を与える
		} else {
			UIMarkupTextPrintFormatter *htmlFormatter =            // formatter を用意する
			[[UIMarkupTextPrintFormatter alloc] initWithMarkupText:text];
			pic.printFormatter = htmlFormatter;  // formatter を与える
		}
		
		pic.printFormatter.startPage = 0;
		pic.printFormatter.contentInsets = UIEdgeInsetsMake(72.0, 72.0, 72.0, 72.0); // 1 inch margins
		pic.printFormatter.maximumContentWidth = 6 * 72.0;
		
		void (^completionHandler)(UIPrintInteractionController *, BOOL, NSError *) =
		^(UIPrintInteractionController *pic, BOOL completed, NSError *error) {
			//self.content = nil;
			if (!completed && error) {
				NSLog(@"FAILED! due to error in domain %@ with error code %u", error.domain, error.code);
			} 
		};
		
		[self printContent:pic completionHandler:completionHandler];
	}
}

// ================================================= webView 関連

- (void)webViewDidStartLoad:(UIWebView *)webView
{
	// starting the load, show the activity indicator in the status bar
	[UIApplication sharedApplication].networkActivityIndicatorVisible = YES;
}

- (void)webViewDidFinishLoad:(UIWebView *)webView
{
	// finished loading, hide the activity indicator in the status bar
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
	NSURL *url = [webView.request URL]; // 終了時の URL を反映させるのが普通らしい
	// urlField.text = [url absoluteString];
	NSLog(@"webViewDidFinishLoad: %@\n", [url absoluteString]);
}

- (BOOL)webView:(UIWebView *)webView shouldStartLoadWithRequest:(NSURLRequest *)request navigationType:(UIWebViewNavigationType)navigationType
{
	NSURL *url = [request URL];
	// urlField.text = [url absoluteString]; // URL フィールドに入れるのが良いらしい
	NSLog(@"shouldStartLoadWithRequest: %@\n", [url absoluteString]);
	return YES;
}

- (void)webView:(UIWebView *)webView didFailLoadWithError:(NSError *)error
{
	// load error, hide the activity indicator in the status bar
	[UIApplication sharedApplication].networkActivityIndicatorVisible = NO;
	
	// report the error inside the webview
	NSString* errorString = [NSString stringWithFormat:
							 @"<html><center><font size=+5 color='red'>An error occurred:<br>%@</font></center></html>",
							 error.localizedDescription];
	[webView loadHTMLString:errorString baseURL:nil];
}

// webView をロードする
- (IBAction)loadWebView:(id)sender {
	myWebView.backgroundColor = [UIColor whiteColor];
	myWebView.scalesPageToFit = YES;
	myWebView.autoresizingMask = (UIViewAutoresizingFlexibleWidth | UIViewAutoresizingFlexibleHeight);
	myWebView.delegate = self;
	
	NSString *url = @"http://bakkers.gr.jp/~yasuda/CBX/";
	
	[myWebView loadRequest:[NSURLRequest requestWithURL:[NSURL URLWithString:url]]];
}

// ================================================= viewPrintFormatter


// viewPrintFormatter を使って印刷, A4, WebView
- (IBAction)printWebView:(id)sender {	
	
	UIPrintInteractionController *pic = [UIPrintInteractionController sharedPrintController];
	
	if(pic) { 
		pic.delegate = self;
				
		UIPrintInfo *printInfo = [UIPrintInfo printInfo];
		printInfo.outputType = UIPrintInfoOutputGeneral;     // A4を指定
		printInfo.jobName = [[myWebView.request URL] absoluteString]; // URL を指定
		printInfo.duplex =  UIPrintInfoDuplexNone;
		pic.printInfo = printInfo;
		pic.showsPageRange = YES;
		
		UIViewPrintFormatter *viewFormatter =       // formatter を用意する
		[myWebView viewPrintFormatter];

		pic.printFormatter = viewFormatter;  // formatter を与える
		
		pic.printFormatter.startPage = 0;
		pic.printFormatter.contentInsets = UIEdgeInsetsMake(72.0, 72.0, 72.0, 72.0); // 1 inch margins
		pic.printFormatter.maximumContentWidth = 6 * 72.0;
		
		void (^completionHandler)(UIPrintInteractionController *, BOOL, NSError *) =
		^(UIPrintInteractionController *pic, BOOL completed, NSError *error) {
			//self.content = nil;
			if (!completed && error) {
				NSLog(@"FAILED! due to error in domain %@ with error code %u", error.domain, error.code);
			} 
		};
		
		[self printContent:pic completionHandler:completionHandler];
	}
}

// ================================================= printPageRenderer

// printPageRenderer を使って写真を印刷, 写真サイズ, 一枚だけとプリクラ状態の両方に対応
- (IBAction)printWithPageRenderer:(id)sender {
	NSString *path = [[NSBundle mainBundle] pathForResource:@"photo" ofType:@"jpg"];
	UIImage *image = [[UIImage alloc] initWithContentsOfFile:path];
					  
	UIPrintInteractionController *pic = [UIPrintInteractionController sharedPrintController];
	
	if(pic) { 
		// pic.delegate = self; // ここでは不要なのか？？他では本当に必要？
		
		void (^completionHandler)(UIPrintInteractionController *, BOOL, NSError *) =
		^(UIPrintInteractionController *pic, BOOL completed, NSError *error) {
			//self.content = nil;
			if (!completed && error) {
				NSLog(@"FAILED! due to error in domain %@ with error code %u", error.domain, error.code);
			} 
		};
		
		UIPrintInfo *printInfo = [UIPrintInfo printInfo];
		printInfo.outputType = UIPrintInfoOutputPhoto;     // 写真用紙を指定
		printInfo.jobName = [path lastPathComponent];
		printInfo.duplex =  UIPrintInfoDuplexNone;
		pic.printInfo = printInfo;
	
		PrintGridPageRenderer *pageRenderer;
		if([sender tag] == 1) { // single printing
			pageRenderer = [[PrintSinglePageRenderer alloc] init]; // 一枚用のレンダラを生成
		} else { // must be grid multi printing
			pageRenderer = [[PrintGridPageRenderer alloc] init]; // グリッド向けのレンダラを生成
			// grid multi printing では枚数指定をチェックし、またヘッダも出す
			pageRenderer.gridMulti = 
			[[NSNumber alloc] initWithInt:gridMultiSegment.selectedSegmentIndex + 2]; // 何分割で出すか指定
			// ヘッダ情報を作ってみる
			UIFont *font = [UIFont fontWithName:HEADER_FONT size:HEADER_FOOTER_TEXT_HEIGHT]; 
			pageRenderer.headerString = @"Grid Printing Sample of Panda.";
			CGSize stringSize = [pageRenderer.headerString sizeWithFont:font];
			pageRenderer.headerHeight = stringSize.height * 2;
		}
		
		pageRenderer.imageToPrint = image;		// 出力すべき画像データを指定してレンダラ設定完了
		
		pic.printPageRenderer = pageRenderer;
		[pageRenderer release];
		
		[self printContent:pic completionHandler:completionHandler];

	}
	
}




@end
